function varargout = Monocot(varargin)
% MONOCOT MATLAB code for Monocot.fig
%      MONOCOT, by itself, creates a new MONOCOT or raises the existing
%      singleton*.
%
%      H = MONOCOT returns the handle to a new MONOCOT or the handle to
%      the existing singleton*.
%
%      MONOCOT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MONOCOT.M with the given input arguments.
%
%      MONOCOT('Property','Value',...) creates a new MONOCOT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Monocot_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Monocot_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Monocot

% Last Modified by GUIDE v2.5 16-Mar-2015 16:28:07

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Monocot_OpeningFcn, ...
                   'gui_OutputFcn',  @Monocot_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Monocot is made visible.
function Monocot_OpeningFcn(hObject, eventdata, h, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Monocot (see VARARGIN)

% Choose default command line output for Monocot
h.output = hObject;

% ROOTS
if ~isempty(varargin)
    h.parameters=varargin{1};
else % default parameters
    taproot = struct('r',2,'a',0.1,'theta',50/180*pi,'lb',2,'la',15,'ln',1,'nob',30,'dx',0.25,...
        'color',[1,0,0],'tropism',[1,1.5,0.2],'successor',2,'rlt',Inf,'gf',1,...
        'name','Tap root');    
    lateral = struct('r',1.3,'a',0.07,'theta',70/180*pi,'lb',2,'la',3,'ln',2,'nob',7,'dx',0.25,...
        'color',[0,1,0],'tropism',[1,1,0.3],'successor',[],'rlt',Inf,'gf',1,...
        'name','Lateral');
    lateral2 = struct('r',0.7,'a',0.05,'theta',70/180*pi,'lb',0,'la',2,'ln',1,'nob',0,'dx',0.25,...
        'color',[0.5,0.5,0],'tropism',[1,0,0.4],'successor',[],'rlt',Inf,'gf',1,...
        'name','Second order lateral');
    basal = struct('r',2,'a',0.1,'theta',75/180*pi,'lb',2,'la',15,'ln',1,'nob',30,'dx',0.25,...
        'color',[0.5,0,0.5],'tropism',[1,1.5,0.2],'successor',2,'rlt',Inf,'gf',1,...
        'name','Basal root');    
    shootborne = basal;
    shootborne.name = 'Shoot borne root';
    shootborne.tropism = [1,1,0.2];
    shootborne.theta = 80/180*pi;
    shootborne.color = [0,0.5,0.5];
    h.parameters = {taproot, lateral, lateral2, basal, shootborne};
end

% PLANT
h.plantingdepth = str2double(get(h.edit4,'String'));
h.firstB = str2num(get(h.edit6,'String'));
h.delayB = str2num(get(h.edit8,'String'));
h.maxB = str2double(get(h.edit17,'String'));
h.nCR = str2num(get(h.edit10,'String'));
h.firstCR = str2num(get(h.edit12,'String'));
h.delayCR = str2num(get(h.edit13,'String'));
h.delayRC = str2num(get(h.edit14,'String'));
h.dzRC = str2num(get(h.edit15,'String'));

% SIMULATION
h.simtime = str2double(get(h.edit2,'String')); % days
h.intermediate = str2double(get(h.edit3,'String'));

% Legend
im = imread('smallmonocot.png');
axes(h.axes1);
imshow(im);

% Update handles structure
guidata(hObject, h);

% UIWAIT makes Monocot wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Monocot_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;




% --- Executes on button press in checkbox11.
function checkbox11_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox11 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(hObject,'Value')
    set(handles.checkbox12,'Enable','on');
    if get(handles.checkbox12,'Value')
        set(handles.pushbutton10,'Enable','off');
    else
        set(handles.pushbutton10,'Enable','on');
    end
    set(handles.text15,'Enable','on');
    set(handles.text16,'Enable','on');
    set(handles.text26,'Enable','on');
    set(handles.edit6,'Enable','on');    
    set(handles.edit8,'Enable','on');      
else
    set(handles.checkbox12,'Enable','off');
    set(handles.pushbutton10,'Enable','off');
    set(handles.text15,'Enable','off');
    set(handles.text16,'Enable','off');
    set(handles.text26,'Enable','off');
    set(handles.edit6,'Enable','off');    
    set(handles.edit8,'Enable','off');      
end


% --- Executes on button press in checkbox5.
function checkbox5_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(hObject,'Value') 
    set(handles.pushbutton2,'Enable','on');
else
    set(handles.pushbutton2,'Enable','off');
end
    
% --- Executes on button press in checkbox6.
function checkbox6_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(hObject,'Value') 
    set(handles.pushbutton3,'Enable','on');
else
    set(handles.pushbutton3,'Enable','off');
end

% Shoot borne roots
function checkbox7_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(hObject,'Value')     
    set(handles.checkbox9,'Enable','on');    
    if get(handles.checkbox9,'Value')
        set(handles.pushbutton4,'Enable','off');
    else
        set(handles.pushbutton4,'Enable','on');
    end
    set(handles.text20,'Enable','on');
    set(handles.text22,'Enable','on');
    set(handles.text23,'Enable','on');
    set(handles.text24,'Enable','on');  
    set(handles.text25,'Enable','on');  
    set(handles.edit10,'Enable','on');    
    set(handles.edit12,'Enable','on');  
    set(handles.edit13,'Enable','on');  
    %set(handles.edit14,'Enable','on');      
    set(handles.edit15,'Enable','on');    
else
    set(handles.pushbutton4,'Enable','off');
    set(handles.checkbox9,'Enable','off');        
    set(handles.text20,'Enable','off');
    set(handles.text22,'Enable','off');
    set(handles.text23,'Enable','off');
    set(handles.text24,'Enable','off');  
    set(handles.text25,'Enable','off');  
    set(handles.edit10,'Enable','off');    
    set(handles.edit12,'Enable','off');  
    set(handles.edit13,'Enable','off');  
    set(handles.edit14,'Enable','off');      
    set(handles.edit15,'Enable','off');      
end

% Shoot borne roots same as tap root
function checkbox9_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox9 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(hObject,'Value')
    set(handles.pushbutton4,'Enable','off');
else
    set(handles.pushbutton4,'Enable','on');
end

% --- Executes on button press in checkbox12.
function checkbox12_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if get(hObject,'Value')
    set(handles.pushbutton10,'Enable','off');
else
    set(handles.pushbutton10,'Enable','on');
end




% Tap root
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.parameters{1} = rootparamUI(handles.parameters{1});
guidata(hObject,handles);


% Basal roots
function pushbutton10_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.parameters{4} = rootparamUI(handles.parameters{4});
guidata(hObject,handles);


% Laterals
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.parameters{2} = rootparamUI(handles.parameters{2});
guidata(hObject,handles);

% 2nd order laterals
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.parameters{3} = rootparamUI(handles.parameters{3},'nobranches');
guidata(hObject,handles);

% --- Executes on button press in pushbutton4.
function pushbutton4_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.parameters{5} = rootparamUI(handles.parameters{5});
guidata(hObject,handles);





% SAVE .m file 
function pushbutton7_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton7 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h=handles;
[filename, pathname] = uiputfile({'*.m'},'Save as');
if ~(isequal(filename,0) || isequal(pathname,0)) % not cancel

    % load template
    load('template.mat');
    
    % define successors
    p = h.parameters;
    [h,p] = setSuccessors(h,p);    
    p = completeParameters(p); % check parameters

    fid = fopen(fullfile(pathname,filename),'w');
    
    fprintf(fid,pre);
    
    if isempty(p{1}.successor)
        sstr = '[]';
    else
        sstr = ['[', num2str(p{1}.successor(1)), ', 1]'];
    end
    
    fprintf(fid,tapMC,p{1}.r(1),p{1}.r(2),p{1}.a(1),p{1}.a(2),p{1}.theta(1),p{1}.theta(2),p{1}.lb(1),...
        p{1}.lb(2),p{1}.la(1),p{1}.la(2),p{1}.ln(1),p{1}.ln(2),p{1}.nob(1),p{1}.nob(2),...
        p{1}.name,p{1}.color(1), p{1}.color(2),p{1}.color(3),...
        p{1}.tropism(1),p{1}.tropism(2),p{1}.tropism(3),...
        p{1}.dx(1), p{1}.rlt(1),p{1}.rlt(2),p{1}.gf(1),sstr); % Tap root

    if get(h.checkbox5,'Value')==1 % Lateral
        if isempty(p{2}.successor)
            sstr = '[]';
        else
            sstr = ['[', num2str(p{2}.successor(1)), ', 1]'];
        end
        fprintf(fid,lateral,p{2}.r(1),p{2}.r(2),p{2}.a(1),p{2}.a(2),...
            p{2}.theta(1),p{2}.theta(2),p{2}.lb(1),p{2}.lb(2), p{2}.la(1),...
            p{2}.la(2), p{2}.ln(1), p{2}.ln(2),p{2}.nob(1), p{2}.nob(2),...
            p{2}.name,p{2}.color(1), p{2}.color(2),p{2}.color(3),...
            p{2}.tropism(1),p{2}.tropism(2),p{2}.tropism(3),...
            p{2}.dx(1), p{2}.rlt(1),p{2}.rlt(2),p{2}.gf(1),sstr);
    end
    
    if get(h.checkbox6,'Value')==1 % Second order lateral
        fprintf(fid,lateral2,p{3}.r(1),p{3}.r(2),p{3}.a(1),p{3}.a(2),...
            p{3}.theta(1),p{3}.theta(2),p{3}.la(1),p{3}.la(2),...        
            p{3}.lb(1),p{3}.lb(2),p{3}.ln(1),p{3}.ln(2),p{3}.nob(1),p{3}.nob(2),...
            p{3}.name,p{3}.color(1), p{3}.color(2),p{3}.color(3),...
            p{3}.tropism(1),p{3}.tropism(2),p{3}.tropism(3),...
            p{3}.dx(1), p{3}.rlt(1),p{3}.rlt(2),p{3}.gf(1),sstr);
    end
    
    if get(h.checkbox11,'Value')==1 % Basal
        if isempty(p{4}.successor)
            sstr = '[]';
        else
            sstr = ['[', num2str(p{4}.successor(1)), ', 1]'];
        end
        fprintf(fid,basal,p{4}.r(1),p{4}.r(2),p{4}.a(1),p{4}.a(2),...
            p{4}.theta(1),p{4}.theta(2),p{4}.lb(1),p{4}.lb(2), p{4}.la(1),...
            p{4}.la(2), p{4}.ln(1), p{4}.ln(2),p{4}.nob(1), p{4}.nob(2),...
            p{4}.name,p{4}.color(1), p{4}.color(2),p{4}.color(3),...
            p{4}.tropism(1),p{4}.tropism(2),p{4}.tropism(3),...
            p{4}.dx(1), p{4}.rlt(1),p{4}.rlt(2),p{4}.gf(1),sstr);
    end    
    
    if get(h.checkbox7,'Value')==1 % Shoot borne
        if isempty(p{5}.successor)
            sstr = '[]';
        else
            sstr = ['[', num2str(p{5}.successor(1)), ', 1]'];
        end
        fprintf(fid,shootborne,p{5}.r(1),p{5}.r(2),p{5}.a(1),p{5}.a(2),...
            p{5}.theta(1),p{5}.theta(2),p{5}.lb(1),p{5}.lb(2), p{5}.la(1),...
            p{5}.la(2), p{5}.ln(1), p{5}.ln(2),p{5}.nob(1), p{5}.nob(2),...
            p{5}.name,p{5}.color(1), p{5}.color(2),p{5}.color(3),...
            p{5}.tropism(1),p{5}.tropism(2),p{5}.tropism(3),...
            p{5}.dx(1), p{5}.rlt(1),p{5}.rlt(2),p{5}.gf(1),sstr);
    end        

    h.firstB = [h.firstB,0];     % in case no sd add 0
    h.delayB = [h.delayB,0];
    h.firstCR = [h.firstCR,0];
    h.delayCR = [h.delayCR,0];
    h.nCR = [h.nCR,0];
    h.delayRC = [h.delayRC,0];
    h.dzRC = [h.dzRC,0];
    fprintf(fid,monocot,h.plantingdepth,h.firstB(1),h.firstB(2),h.delayB(1), ...
        h.delayB(2),h.maxB,h.firstCR(1),h.firstCR(2),h.delayCR(1),h.delayCR(2),...
        h.nCR(1),h.nCR(2),h.delayRC(1),h.delayRC(2),h.dzRC(1),h.dzRC(2));       
    fprintf(fid,simMonocot,h.simtime,h.simtime/(h.intermediate+1));    
    fprintf(fid,viz);        
    fprintf(fid,example);
    fclose(fid);           
    
end



% SIMULATE
function pushbutton8_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h = handles;

% define successors
p = h.parameters;
[h,p] = setSuccessors(h,p);

% Simulation
completeParameters(p);
simtime = h.simtime;
steps = h.intermediate+1; 
str0 = createMonocotRS(h.plantingdepth,h.firstB,h.delayB,h.maxB,0.1,...
    h.firstCR,h.delayCR,h.nCR,h.delayRC,h.dzRC);

% nasty detail: shootborne roots angle is determined in createMonocotRS,
% and must be set to 0 before simulation
p{5}.theta = 0;  
completeParameters(p);

wh = waitbar(0,'Simulation...');
for i = 1 : steps
    if i==1 
        str{i} = applyRules(str0,simtime/steps);
    else
        str{i} = applyRules(str{i-1},simtime/steps);
    end
    waitbar(i/steps,wh)    
end
close(wh);
pause(0.1); % no idea why i need this

assignin('base','str',str);
assignin('base','simtime',(simtime/steps).*(1:steps));

% viewer GUI
viewerUI(str,simtime);





function [h,p]=setSuccessors(h,p)
% set successors in dependence of the checkboxes
p{4}.successor = []; % 2nd order laterals
if get(h.checkbox5,'Value') % laterals exist
    p{1}.successor = 2; % tap
    p{4}.successor = 2; % basal
    p{5}.successor = 2; % shootborne
else
    p{1}.successor = [];
    p{4}.successor = [];
    p{5}.successor = [];
end
if get(h.checkbox6,'Value') % 2nd order laterals
    p{2}.successor = 3; % laterals
else
    p{2}.successor = [];
end   
if get(h.checkbox11,'Value') % Basal roots
    if get(h.checkbox12,'Value') % basal = tap
        p{4} = p{1};
        p{4}.name = 'Basal root'; 
        p{4}.theta = 75/180*pi; % override theta
        p{4}.color = [0.5,0,0.5];
        p{4}.tropism = [1,1,0.2];
    end
else
   h.firstB = [Inf,0]; % never 
end
if get(h.checkbox7,'Value') % Shoot borne roots
    if get(h.checkbox9,'Value') % shoot borne = basal
        p{5} = p{4};
        p{5}.name = 'Shoot borne root';        
        p{5}.color = [0,0.5,0.5];
        p{5}.tropism = [1,1,0.2];
    end
else
    h.firstCR = [Inf,0]; % never 
end


function edit2_Callback(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit2 as text
%        str2double(get(hObject,'String')) returns contents of edit2 as a double

simtime = str2double(get(hObject,'String'));
simtime = min(max(simtime,1),365);
set(hObject,'String',num2str(simtime));
handles.simtime = simtime;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit3_Callback(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit3 as text
%        str2double(get(hObject,'String')) returns contents of edit3 as a double

ir = str2double(get(hObject,'String'));
ir = min(max(ir,0),1e3);
set(hObject,'String',num2str(ir));
handles.intermediate = ir;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Planting depth
function edit4_Callback(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit4 as text
%        str2double(get(hObject,'String')) returns contents of edit4 as a double

depth = str2double(get(hObject,'String'));
depth = min(max(depth,0),20);
set(hObject,'String',num2str(depth));
handles.plantingdepth = depth;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% LOAD
% --------------------------------------------------------------------
function uipushtool1_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to uipushtool1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h = handles;

[filename, pathname] = uigetfile('*.mat', 'Select root system');
if ~isequal(filename,0) % not cancel
    
    load(fullfile(pathname, filename));
    if exist('parameters') % flexible
        h.parameters = parameters;
    elseif exist('parameter')
        h.parameters = parameter;
    elseif exist('p')
        h.parameters = p;
    end
    h.parameters=completeParameters(h.parameters);
    
    if exist('monocot')==1
        h.plantingdepth = monocot.plantingdepth;                
        h.firstB = monocot.firstB;
        h.delayB = monocot.delayB;
        h.maxB = monocot.maxB;
        h.nCR = monocot.nCR;
        h.firstCR = monocot.firstCR;
        h.delayCR = monocot.delayCR;
        h.delayRC = monocot.delayRC;
        h.dzRC = monocot.dzRC;
        h.simtime = monocot.simtime;
        h.intermediate = monocot.intermediate;
        % update gui
        set(h.checkbox5,'Value',monocot.cb(1));
        set(h.checkbox6,'Value',monocot.cb(2));
        set(h.checkbox7,'Value',monocot.cb(3));
        set(h.checkbox9,'Value',monocot.cb(4));
        set(h.checkbox11,'Value',monocot.cb(5));
        set(h.checkbox12,'Value',monocot.cb(6));

        if length(h.firstB)>1
            set(h.edit6,'String',['[ ',num2str(h.firstB),' ]']);
        else
            set(h.edit6,'String',num2str(h.firstB));
        end
        if length(h.delayB)>1
            set(h.edit8,'String',['[ ',num2str(h.delayB),' ]']);
        else
            set(h.edit8,'String',num2str(h.delayB));
        end
        if length(h.firstCR)>1
            set(h.edit12,'String',['[ ',num2str(h.firstCR),' ]']);
        else
            set(h.edit12,'String',num2str(h.firstCR));
        end
        if length(h.delayCR)>1
            set(h.edit13,'String',['[ ',num2str(h.delayCR),' ]']);
        else
            set(h.edit13,'String',num2str(h.delayCR));
        end
        if length(h.nCR)>1
            set(h.edit10,'String',['[ ',num2str(h.nCR),' ]']);
        else
            set(h.edit10,'String',num2str(h.nCR));
        end
        if length(h.delayRC)>1
            set(h.edit14,'String',['[ ',num2str(h.delayRC),' ]']);
        else
            set(h.edit14,'String',num2str(h.delayRC));
        end
        if length(h.dzRC)>1
            set(h.edit15,'String',['[ ',num2str(h.dzRC),' ]']);
        else
            set(h.edit15,'String',num2str(h.dzRC));
        end
        %
        set(h.edit17,'String',num2str(monocot.maxB));
        set(h.edit4,'String',num2str(monocot.plantingdepth));        
        set(h.edit2,'String',num2str(monocot.simtime));
        set(h.edit3,'String',num2str(monocot.intermediate));                
    else
        if exist('dicot')==1
            warndlg('Please open in Dicot Plant GUI','Warning','modal');
        else
            warndlg('Monocot plant data is missing','Warning','modal');
        end
    end        
    guidata(hObject,h);
    checkbox5_Callback(h.checkbox5, [], h);
    checkbox6_Callback(h.checkbox6, [], h);
    checkbox7_Callback(h.checkbox7, [], h);
    checkbox9_Callback(h.checkbox9, [], h);
    checkbox11_Callback(h.checkbox11, [], h);    
    checkbox12_Callback(h.checkbox12, [], h);       
    
end


% SAVE
% --------------------------------------------------------------------
function uipushtool2_ClickedCallback(hObject, eventdata, handles)
% hObject    handle to uipushtool2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h=handles;
[filename, pathname] = uiputfile({'*.mat'},'Save as');
if ~(isequal(filename,0) || isequal(pathname,0)) % not cancel
    
    % root parameters
    parameters = h.parameters;
    
    % additional root system parameters
    monocot.plantingdepth = h.plantingdepth;
    monocot.firstB = h.firstB;
    monocot.delayB = h.delayB;    
    monocot.maxB = h.maxB;
    monocot.nCR = h.nCR;
    monocot.firstCR = h.firstCR;
    monocot.delayCR = h.delayCR;
    monocot.delayRC = h.delayRC;
    monocot.dzRC = h.dzRC;        
    monocot.simtime = h.simtime;
    monocot.intermediate = h.intermediate;   
    monocot.cb = [get(h.checkbox5,'Value'),get(h.checkbox6,'Value'), ... 
        get(h.checkbox7,'Value'),get(h.checkbox9,'Value'),...
        get(h.checkbox11,'Value'),get(h.checkbox12,'Value')]; % checkboxes
    
    % save file
    save(fullfile(pathname,filename),'parameters','monocot');
    
    % copy to workspace
     assignin('base','parameters',parameters);     
     assignin('base','monocot',monocot);   
end



% Second basal root emergence (day)
function edit6_Callback(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit6 as text
%        str2double(get(hObject,'String')) returns contents of edit6 as a double

fb = str2num(get(hObject,'String'));
fb = min(max(fb,0),365);
if length(fb)>1
    set(hObject,'String',['[ ',num2str(fb),' ]']);
else
    set(hObject,'String',num2str(fb));    
end
handles.firstB = fb;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% basal root delay
function edit8_Callback(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit8 as text
%        str2double(get(hObject,'String')) returns contents of edit8 as a double

bd = str2num(get(hObject,'String'));
bd = min(max(bd,0),365);
if length(bd)>1
    set(hObject,'String',['[ ',num2str(bd),' ]']);
else
    set(hObject,'String',num2str(bd));    
end
handles.delayB = bd;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit8_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit8 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% first shootborne root
function edit12_Callback(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit12 as text
%        str2double(get(hObject,'String')) returns contents of edit12 as a double

firstCR = str2num(get(hObject,'String'));
firstCR = min(max(firstCR,0),365);
if length(firstCR)>1
    set(hObject,'String',['[ ',num2str(firstCR),' ]']);
else
    set(hObject,'String',num2str(firstCR));    
end
handles.firstCR = firstCR;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit12_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit12 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% delay between shootborne roots
function edit13_Callback(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit13 as text
%        str2double(get(hObject,'String')) returns contents of edit13 as a double

delayCR = str2num(get(hObject,'String'));
delayCR = min(max(delayCR,0),365);
if length(delayCR)>1
    set(hObject,'String',['[ ',num2str(delayCR),' ]']);
else
    set(hObject,'String',num2str(delayCR));    
end
handles.delayCR = delayCR;
% update edit14
nCR = str2num(get(handles.edit10,'String'));
d = delayCR.*nCR;
set(handles.edit14,'String',num2str(d(1)));    

guidata(hObject,handles);



% --- Executes during object creation, after setting all properties.
function edit13_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit13 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% number of roots per root crown
function edit10_Callback(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit10 as text
%        str2double(get(hObject,'String')) returns contents of edit10 as a double

nCR = str2num(get(hObject,'String'));
nCR = min(max(nCR,0),99);
if length(nCR)>1
    set(hObject,'String',['[ ',num2str(nCR),' ]']);
else
    set(hObject,'String',num2str(nCR));    
end
handles.nCR = nCR;
% update edit14
nCR = str2num(get(handles.edit13,'String'));
d = handles.delayCR.*nCR;
set(handles.edit14,'String',num2str(d(1)));
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit10_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit10 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% delay between root crowns
function edit14_Callback(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit14 as text
%        str2double(get(hObject,'String')) returns contents of edit14 as a double

delayRC = str2num(get(hObject,'String'));
delayRC = min(max(delayRC,0),365);
if length(delayRC)>1
    set(hObject,'String',['[ ',num2str(delayRC),' ]']);
else
    set(hObject,'String',num2str(delayRC));    
end
handles.delayRC = delayRC;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit14_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit14 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% distance between CR 
function edit15_Callback(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit15 as text
%        str2double(get(hObject,'String')) returns contents of edit15 as a double

dzRC = str2num(get(hObject,'String'));
dzRC = min(max(dzRC,0),20);
if length(dzRC)>1
    set(hObject,'String',['[ ',num2str(dzRC),' ]']);
else
    set(hObject,'String',num2str(dzRC));    
end
handles.dzRC = dzRC;
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit15_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit15 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit17_Callback(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit17 as text
%        str2double(get(hObject,'String')) returns contents of edit17 as a double

maxB = str2double(get(hObject,'String'));
maxB = min(max(maxB,0),100);
handles.maxB = maxB;
guidata(hObject,handles);




% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called





% --- Executes during object creation, after setting all properties.
function edit17_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
